---
name: Bug report
about: Create a report to help us improve ExRam.Gremlinq
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of the unexpected behavior you are observing.

**Expected behavior**
A clear and concise description of what you expected to happen.

**Version information**
Tell us which version of ExRam.Gremlinq you are using.

**Minimal working example**
You **MUST** provide one of the following

- a link to GitHub repository containing a minimal executable project
structure that exposes the unexpected behaviour. By 'minimal' we mean that you should omit any code
that is not directly necessary to show the unexpected behaviour. **Make sure you remove any sensible
data (e.g. passwords etc). Don't post tons of business POCOs or DTOs that
are not really relevant for exposing the unexpected behaviour.**

- a pull request to ExRam.Gremlinq that adds a failing unit test to the ExRam.Gremlinq tests asserting
the expected behaviour. Again, this should be minimal to reduce noise.

**In any case:**

- The repro code must be able to checkout and run in the matter of minutes. If the issue contains neither of these things and/or just incomplete code snippets it may be labelled accordingly and become stale.
Please understand that I ask for this much effort from you in exchange for my work since it is tedious and time-consuming to isolate the relevant bits from an issue each time just to setup
a new project that might not expose the unexpected behavior.

- Do not post screenshots of code in an IDE. I won't read from images, nor will I tediously copy code from an image into a project.

**Additional context**
Add any other context about the problem here.
