﻿using System.Linq.Expressions;

namespace ExRam.Gremlinq.Core
{
    public interface IMapGremlinQueryBase :
        IGremlinQueryBase
    {
    }

    public interface IMapGremlinQueryBase<TElement> :
        IMapGremlinQueryBase,
        IGremlinQueryBase<TElement>
    {
        IGremlinQuery<TValue> Select<TValue>(Expression<Func<TElement, TValue>> projection);

        IMapGremlinQuery<(TItem1, TItem2)> Select<TItem1, TItem2>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2);
        IMapGremlinQuery<(TItem1, TItem2, TItem3)> Select<TItem1, TItem2, TItem3>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4)> Select<TItem1, TItem2, TItem3, TItem4>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5)> Select<TItem1, TItem2, TItem3, TItem4, TItem5>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11, Expression<Func<TElement, TItem12>> projection12);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11, Expression<Func<TElement, TItem12>> projection12, Expression<Func<TElement, TItem13>> projection13);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11, Expression<Func<TElement, TItem12>> projection12, Expression<Func<TElement, TItem13>> projection13, Expression<Func<TElement, TItem14>> projection14);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14, TItem15)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14, TItem15>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11, Expression<Func<TElement, TItem12>> projection12, Expression<Func<TElement, TItem13>> projection13, Expression<Func<TElement, TItem14>> projection14, Expression<Func<TElement, TItem15>> projection15);
        IMapGremlinQuery<(TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14, TItem15, TItem16)> Select<TItem1, TItem2, TItem3, TItem4, TItem5, TItem6, TItem7, TItem8, TItem9, TItem10, TItem11, TItem12, TItem13, TItem14, TItem15, TItem16>(Expression<Func<TElement, TItem1>> projection1, Expression<Func<TElement, TItem2>> projection2, Expression<Func<TElement, TItem3>> projection3, Expression<Func<TElement, TItem4>> projection4, Expression<Func<TElement, TItem5>> projection5, Expression<Func<TElement, TItem6>> projection6, Expression<Func<TElement, TItem7>> projection7, Expression<Func<TElement, TItem8>> projection8, Expression<Func<TElement, TItem9>> projection9, Expression<Func<TElement, TItem10>> projection10, Expression<Func<TElement, TItem11>> projection11, Expression<Func<TElement, TItem12>> projection12, Expression<Func<TElement, TItem13>> projection13, Expression<Func<TElement, TItem14>> projection14, Expression<Func<TElement, TItem15>> projection15, Expression<Func<TElement, TItem16>> projection16);
    }

    public interface IMapGremlinQuery<TElement> :
        IMapGremlinQueryBase<TElement>,
        IGremlinQueryBaseRec<TElement, IMapGremlinQuery<TElement>>
    {

    }
}
